/*
 * Created on Aug 10, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author davide
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */


import java.io.*;
import java.util.*;

public class ConfigHandler {

	ArrayList configs = new ArrayList();
	ArrayList rules   = new ArrayList();
	
	public ConfigHandler(String fconf) throws Exception {
		// Open and read the configuration file
		File f = new File(fconf);
		if (!f.exists())
			throw new Exception ("File "+fconf+" doesn't exist");
		String str_conf = "";
		int ch;
		BufferedReader br = new BufferedReader( new FileReader(f) );
		while ( (ch = br.read()) != -1 )
			str_conf += (char)ch;
		br.close();
		// every line is a rule (or a comment), so get them!
		String[] kv = str_conf.split("\n");
		// parse every line!
		for (int i=0;i<kv.length;i++) {
			kv[i] = kv[i].replaceAll("\r","");
			kv[i] = kv[i].trim();
			// if it's a comment skip it
			if (kv[i].startsWith("#"))
				continue;
			// a line is key=value, so get the two values
			String[] key_val = kv[i].split("=");
			if (key_val.length!=2)
				continue;
			// clean up the key-value pair
			key_val[0] = key_val[0].trim();
			key_val[1] = key_val[1].trim();
			if (key_val[0].equals("") || key_val[1].equals(""))
				continue;
			// parse the rule!!!
			if (key_val[0].startsWith("clean_rule")) {
				String rr = "";
				// read the specified file and add the clean-rule
				if (key_val[0].equals("clean_rule_file")) {
					BufferedReader br2 = new BufferedReader( new FileReader(key_val[1]) );
					ch = 0;
					while( (ch=br2.read())!=-1)
						rr += (char)ch;
					if (rr.endsWith("\r") ) {
						rr = rr.substring(0,rr.length()-1);
					}
					else
					if (rr.endsWith("\r\n")) {
						rr = rr.substring(0,rr.length()-2);
					}
					else
					if (rr.endsWith("\n")) {
						rr = rr.substring(0,rr.length()-1);
					}
					br2.close();
				}
				else
				if (key_val[0].equals("clean_rule"))
					rr = key_val[1];
				if (!rr.equals(""))
					rules.add(rr);
			}
			else
				configs.add(key_val[0]+"="+key_val[1]);
		}
	}

	public String getConfigValue(String paramname) throws Exception {
		// get the value of the given parameter
		String ret = "";
		int ok = -1;
		ok = getConfigIndex(paramname);
		if (ok<0)
		    throw new Exception("No param "+paramname+" found");
		String[] kv = configs.get(ok).toString().split("=");				
		ret = kv[1];
		return ret;
	}

	public int getConfigIndex(String paramname) {
		for (int i=0;i<configs.size();i++) {
			String[] kv = configs.get(i).toString().split("=");
			if (paramname.equals(kv[0])) {
			    return i;
			}	
		}
		return -1;
	} 
	
	public void setConfigValue(String cname,String cvalue) {
	    int p = getConfigIndex(cname);
	    if (p<0) {
		configs.add(cname+"="+cvalue);
	    }
	    else {
		configs.set(p,cname+"="+cvalue);
	    }
	    return ;
	}
	
	public int getTotRules() {
		// get the size of the rules-list
		return rules.size();
	}
	
	public String getRuleValue(int index) throws Exception{
		// get the value of the given rule (by index)
		if (index<0 || index>getTotRules()) {
			throw new Exception ("Rule index out of range");
		}
		return rules.get(index).toString();
	}
	
}
