
import java.util.*;
import java.net.*;

class Find_JAP extends Thread  {

	final static int port = 30666;
	final static int ack_port = 30667;
	final static int max_loops = 90;
	final static int max_failed_accepts = 30;
	final static int min_delta_loop_random = 6;
	DatagramSocket rcv_udp_sock = null;
	boolean all_ok = false;
	static ArrayList proxys = new ArrayList();
	final static int MAX_BUFFLEN = 64000;
	boolean stop_me =  false;
	static boolean updating = false;
	static ConfigHandler cfg = null;
	static Random rnd = new Random();	
	
	public Find_JAP(ConfigHandler hcfg) {
		try {
			rcv_udp_sock = new DatagramSocket(ack_port);	
			all_ok = true;
			cfg = hcfg;
		}
		catch (Exception ex) {
			System.out.println("Error while creating Find_JAP: "+ex);
		}
	}

	
	public void close_all() {
		stop_me = true;
	}
		
	static public InetAddress get_jap_proxy() {
		int pos = 0;
		boolean ok = false;
		int loops = 0;
		for (long l=0L;l<=100000L;l++); // wait some time to give time to run&co. to retrive some proxy address ;-)
		while (updating) { // busy waiting 
		    //System.out.println("Waiting ...");
		    try {
			sleep(500);
		    }
		    catch (Exception ex) {}
		    loops ++;
		    if (loops > max_loops) {
			// ok, we ran out of patience
			System.out.println("We waited for "+(loops * 0.5)+" seconds but no proxy found!");
			return null;
		    }
		}
		while (!ok) {
			//System.out.println("L"+proxys.size());
			if (proxys.size()==0 || proxys.isEmpty())	{
				//System.out.println("X");
				boolean real_empty = true;
				for (int wcx=0;wcx<3;wcx++) {
				    System.out.println("Waiting "+(wcx+1)+"/3 times..");
				    if (proxys.isEmpty() || proxys.size()==0) {
					try { sleep(5000); } catch (Exception ex) {}
				    }
				    else {
					real_empty = false;
					break;
				    }	
				}
				if (real_empty) {
			    	    updating = false;
				    System.out.println("NO Proxys!");	
				    return null;
				}    
		    }
		    if (proxys.size()>1) {
			    pos = rnd.nextInt(proxys.size());	
		    }
		    else 
			pos = 0;
		    try {
			// open a tcp connection to see if it's ok&online	
			Socket test = new Socket((InetAddress)(proxys.get(pos)),4001);
			ok = true;
			test.close();
		    }
		    catch (Exception ex) {
			proxys.remove(pos);
			ok = false;
		    }
		}
		System.out.println("Proxy "+(pos+1)+"/"+proxys.size()+" chosen!");
		return (InetAddress)(proxys.get(pos));
	}
	
	public boolean is_ok() {
		return all_ok;
	}
	
	public void run() {
		int loops = 0;
		int failed_accepts = 0;
		int delta_loop = 0;
		System.out.println("Starting Find_JAP!");
		while (true) {
			if (stop_me) {
				rcv_udp_sock.close();
				break;				
			}
			try {
				if (loops == 0 || loops >= max_loops || failed_accepts >= max_failed_accepts) {
					// clear&renew proxy list
					updating = true;
					loops = 0;
					failed_accepts = 0;
					proxys.clear();
					send_ack_request();
					sleep(10000);							
				}
				else {
				    if (loops % ((int)(max_loops / 3)) == 0 || (rnd.nextInt(max_loops) > (max_loops/2) && delta_loop>=min_delta_loop_random) ) {
					// update proxy list at 1/3 , 2/3 max_loops 
					delta_loop = 0;	
					send_ack_request();
				    }
				}
			} catch (Exception e) {}	
			loops ++;
			delta_loop ++;
			InetAddress a = get_jap_ack();
			if (a != null) {
				updating = false;
				boolean pok = false;
				for (int ij=0;ij<proxys.size();ij++) {
				    if (proxys.get(ij).toString().equals(a.toString())) {
					    pok = true;
					    break;
					}
				}	
				if (!pok) {
				    System.out.println("Adding JAP Proxy "+a);				
				    proxys.add(a);
				}    
				failed_accepts = 0;
			}	
			else
			    failed_accepts ++;
		}
	}
	
	void send_ack_request() throws Exception {
		  if (!all_ok)
		  	throw new Exception("Find_JAP::send_ack_request - Find_JAP not started!");
		  DatagramSocket socket = new DatagramSocket();
		  String Spacket = new String("JAP");
		  byte[] b = Spacket.getBytes();
		  DatagramPacket dgram;	
		  String ips[] = cfg.getConfigValue("jap_proxy").split(",");
		  DatagramPacket dg_p = null;
		  for (int i=0;i<ips.length;i++) {
			//dgram = new DatagramPacket(b, b.length, InetAddress.getByName("5.255.255.255"), port);
			dgram = new DatagramPacket(b, b.length, InetAddress.getByName(ips[i]), port);
			//System.out.println("Sending " + b.length + " bytes to " + dgram.getAddress() + ':' + dgram.getPort());
			socket.send(dgram);
			// ok, all ok .... try to send back (if a JAP_bridge is present)
			// our list of "JAP_modified proxies"
			try {
				if (cfg.getConfigValue("allow_remote_proxy_list").equals("yes")) {
				    String dg_list = "JAPs,"+cfg.getConfigValue("jap_proxy"); // in the future make this string <= 64000 chars
				    byte dg_b [] = dg_list.getBytes();
				    dg_p = new DatagramPacket(dg_b,dg_b.length,InetAddress.getByName(ips[i]),ack_port);
				    System.out.println("Sending local proxy list to "+ips[i]+":"+ack_port);
			    	    socket.send(dg_p);
				}
			}
			catch (Exception e) {
				// oops, we can't send back anything ... 
				// maybe the next time we'll can ;-)
			}


		  }
		  dg_p = null;
		  socket.close();	
	}
	
	InetAddress get_jap_ack() {
		try {
			if (!all_ok)
		  		throw new Exception("Find_JAP::get_jap_ack - Find_JAP not started!");
			DatagramPacket dp;
			byte[] b = new byte[MAX_BUFFLEN];
			String rstr = "";
			dp = new DatagramPacket(b, b.length);			
			if (rcv_udp_sock.isClosed())
				return null;
			rcv_udp_sock.setSoTimeout(10000);
			rcv_udp_sock.receive(dp);
			for (int i=0;i<b.length;i++) {
				if (b[i]!=0)
					rstr += (char)b[i];
				else
					break;	
			}		
			if (rstr.startsWith("JAPs,") && cfg.getConfigValue("allow_remote_proxy_list").equals("yes")) {
			    System.out.println("Received remote proxy list from "+dp.getAddress()+":"+dp.getPort()); 
			    String tmp1[] = cfg.getConfigValue("jap_proxy").split(",");
			    String tmp2[] = rstr.substring(5).split(",");
			    int i,j;
			    for ( i=0;i<tmp1.length;i++) 
				for (j=0;j<tmp2.length;j++)
				    if (tmp1[i].equals(tmp2[j])) {
					tmp1[i] = "";
				    }	
			    String resp = "";
			    for (i=0;i<tmp1.length;i++)
				if (!tmp1[i].equals("")) {
				    if (resp.equals(""))
					resp = tmp1[i];
				    else
					resp += ","+tmp1[i];	
				}    
			    for (i=0;i<tmp2.length;i++)
				if (!tmp2[i].equals("")) {
				    if (resp.equals(""))
					resp = tmp2[i];
				    else
					resp += ","+tmp2[i];	
				}
			    cfg.setConfigValue("jap_proxy",resp);
			    System.out.println("Setting  proxy list for the next 'send_ack request' as '"+resp+"'");
			}
			if (!rstr.equals("JAP"))		
				return null;
			// System.out.println("Receiving " + b.length + " bytes ["+rstr+"] from " + dp.getAddress() + ':' + dp.getPort());
			try {
			// open a tcp connection to see if it's ok&online	
			    Socket test = new Socket(dp.getAddress(),4001);
			    test.close();
			}
			catch (Exception ex) {
			    return null;
			}
			return dp.getAddress();			
		}
		catch (SocketTimeoutException ex) {
			//System.out.println("Timeout while waiting for JAP ack!");
			return null;
		}
		catch (Exception ex) {
			System.out.println("Error while getting JAP ack: "+ex.toString());
			return null;
		}
	}
	
	

}



