/*
 * Created on Aug 10, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author davide
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import java.net.*;
import java.util.regex.*;


public class ListenerDaemon extends Thread {

	ConfigHandler hcfg = null;
	ServerSocket ss = null;
	String ip_ok = null;
	Pattern pex = null;
	Find_JAP fjap = null;
    	
	public boolean halt_now = false;
	
	public ListenerDaemon(int port,String valid_ip,ConfigHandler cfg) throws Exception {
		// initialize the listener opening the socket and creating the regex pattern
		super();
		ss = new ServerSocket(port);
		hcfg = cfg;
		ip_ok = valid_ip;
		pex = Pattern.compile(ip_ok);
		fjap = new Find_JAP(hcfg);
	}

	public void run() {
		if (!fjap.is_ok()) {
			System.out.println("Unable to create Find_JAP Thread , Exiting!");
			try {
				ss.close();			
			}
			catch (Exception ex) {
				System.out.println("Warning: "+ex.toString()+"\n");
			}
		}
		System.out.println("Starting Listener Daemon...\n");
		fjap.start();
		while (!halt_now) {
			Socket s = null;
			try {
				try {
					// set timeout to .5 secs
					ss.setSoTimeout(500);
					// wait for incoming connections 
					s = ss.accept();
				}
				catch (SocketTimeoutException ex) {
					// no incoming request in timeout interval
					continue;
				}
			}
			catch (Exception ex) {
				System.out.println("Error while receiving connection request:\n"+ex.getMessage()+"\n");
			}
			// check if IP is valid according to ip_ok using regular expressions
			String rem_ip = s.getInetAddress().getHostAddress();
			Matcher mex = pex.matcher(rem_ip);
			if (!mex.matches()) {
				System.out.println("Rejected connection from "+s.toString()+"\nIt doesn't match "+ip_ok+"\n");
				try {
					s.close();
				}
				catch (Exception ex) {
					System.out.println("Warning: "+ex.getMessage()+"\n");
				}
				s = null;
			}
			else {
				try {
					// ok, start the proxy!
					Proxy p = new Proxy(s,hcfg,this, fjap,/*jap port*/ 4001);
					p.start();
				}
				catch (Exception ex) {
					System.out.println("Error while creating Proxy for "+s+"\n");
				}
			}
		}
		System.out.println("Stopping Listener Daemon...\n");
		try {
			ss.close();
		}
		catch (Exception ex) {
			System.out.println("Warning: "+ex.getMessage()+"\n");
		}
		fjap.close_all();		
		System.out.println("Halted!\n");
	}
	
}
