/*
 * Created on Aug 10, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author davide
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import java.net.*;
import java.io.*;
import java.util.*;

class ProxyChannel extends Thread{

    Proxy parent = null;
    BufferedReader br = null;
    BufferedWriter bw = null;
    String name = "";
    boolean print_rw = false; 
    final static int max_read_chunk = 1000;
    long bytes = 0;
    boolean first_half = false;
    String pre = "";
    
    public ProxyChannel(Proxy p,BufferedReader b_r,BufferedWriter b_w,String n,boolean prw,boolean fa,String au) {
	parent = p;
	br = b_r;
	bw = b_w;
	name = n;
	print_rw = prw;
	first_half = fa;
	pre = au;
    }
    
    public void run() {
	int ch = -1;
	int chunk = 0;
	String first_line = "";
	int line = 0;
	System.out.println("Starting ProxyChannel "+name);
	try {
	    if (!pre.equals("")) {
		byte pby[] = pre.getBytes();
		for (int ibt=0;ibt<pby.length;ibt++)
			bw.write((int)pby[ibt]);
		bw.flush();
		first_line += pre;
	    }
	    while ((ch = br.read())!=-1) {
		bw.write(ch);
		chunk ++;
		bytes++;
		bw.flush();
		if (line==0)
		    first_line += (char)ch;
		if ((char)ch=='\n' && line==0) {
		    System.out.println(name+" first line: "+first_line);
		    line ++;
		}
		if (chunk>=max_read_chunk) {
		    chunk = 0;
		    bw.flush();
		}
	        if (print_rw)
			System.out.print((char)ch); 
 	    }
	    bw.flush();
	    if (!first_half)
		parent.stop_proxy ++;	
	    System.out.println("ProxyChannel "+name+" finished its work: "+bytes+" bytes");
	}
	catch (Exception ex) {
	    parent.channel_ex = ex;
	}
    }
}


public class Proxy extends Thread{

	Socket s = null;
	ConfigHandler hcfg = null;
	ListenerDaemon ld = null;
	InetAddress jap_proxy = null;
	Find_JAP fjap = null;
	int jap_proxy_port = 0;
	public Exception channel_ex = null;
	public int stop_proxy = 0;
	
	public Proxy(Socket sloc,ConfigHandler cfg, ListenerDaemon caller,Find_JAP jap,int jap_port) throws Exception {
		// initialize all we need
		super();
		s = sloc;
		hcfg = cfg;
		ld = caller;
		fjap = jap;
		jap_proxy_port = jap_port;
	} 
	
	public void run() {
		boolean kill_caller = false;
		String kuser = "";
		String kpass = "";
		System.out.println("Starting Proxy for "+s+"\n");
		BufferedReader br = null;
		BufferedWriter bw = null;
		Socket sproxy = null;
		BufferedWriter pbw = null;
		BufferedReader pbr = null;
		String pre_in = "";
		// create input/output stream needed to communicate with the caller!
		try {
			br = new BufferedReader( new InputStreamReader(s.getInputStream()));
			bw = new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));
		}
		catch (Exception ex) {
			System.out.println("Error while creating I/O Stream from/to "+s+"\n");
			System.out.println("Aborting Proxy for "+s+"\n");
			return;
		}
		// find a proxy!
		try {
		    // before searching for a proxy check if it's a KILL request!
			pre_in = ""+(char)br.read();
			if (pre_in.equals("K")) {
			    int ch = -1, tot_lines = 0;
			    String auser = hcfg.getConfigValue("admin_user");
			    String apass = hcfg.getConfigValue("admin_password");
    			    //System.out.println("KILL?");
			    String http_request = "K";
			    while ((ch=br.read())!=-1) {
				pre_in += (char)ch;
				if ((char)ch=='\n')
					tot_lines ++;
				if (tot_lines == 4)
				    break;	
			    }
			    // System.out.println(pre_in);
			    // split the request into lines
			    String tmp[] = pre_in.split("\r\n");
			    if (tmp[0].equals("KILL")) {
				// listener shutdown request 
				try {
					// System.out.println(kuser+"/"+tmp[1]+" "+kpass+"/"+tmp[2]+"\n");
					// check if given admin user/password are ok
					if (tmp[1].equals(auser) && tmp[2].equals(apass)) {
						kill_caller = true;
					}	
					else
						System.out.println("Error in Proxy for "+s+":\nAdmin user and password invalid!\n");
				}
				catch (Exception ex) {
					System.out.println("Error in Proxy for "+s+":\n"+ex.getMessage()+"\n");
				}
			    }
		    }
		  if (!kill_caller)    	
		  {    
		    jap_proxy = fjap.get_jap_proxy();
		    if (jap_proxy == null) {
			// aaargh, no proxy
			try { br.close(); bw.close(); s.close(); } catch (Exception ex) {}
			System.out.println("Unable to find a valid proxy!");
			return;
		    }
		    System.out.println("Using JAP at "+jap_proxy+":"+jap_proxy_port+"\n");									      
		    sproxy = new Socket(jap_proxy,jap_proxy_port);
		    System.out.println("Proxy for "+s+" sending request to JAP "+jap_proxy+":"+jap_proxy_port+"\n");
		    pbw = new BufferedWriter(new OutputStreamWriter(sproxy.getOutputStream()));
		    pbr = new BufferedReader(new InputStreamReader(sproxy.getInputStream()));		
		    // bw = writer to local , pbw = writer to remote proxy
		    // br = reader from local, pbr = reader from remote proxy
		    ProxyChannel local2remote = new ProxyChannel(this,br,pbw,""+s+"->"+sproxy,false,true,
								  pre_in);
		    local2remote.start();
		    ProxyChannel remote2local = new ProxyChannel(this,pbr,bw,""+sproxy+"->"+s,false,false,"");
		    remote2local.start();
		    while (stop_proxy<1) {
			if (channel_ex != null)
			    throw channel_ex;
			try { sleep(1000); } catch (Exception ezero) {}    
		    }
		    if (stop_proxy == 255) {
			kill_caller = true;
		    }
		  }    
		}
		catch (Exception ex) {
			System.out.println("Error in Proxy for "+s+":\n"+ex.getMessage()+"\n");
		}
		// -- /proxy code --
		if (kill_caller) {
				// the "client" sent us a "proxy shutdown" command
				// so we have to notify it to the Listener ...
				ld.halt_now = true;
				System.out.println("Proxy for "+s+" request caller shutdown\n");	
		}
		System.out.println("Stopping Proxy for "+s+"\n");
		try {
			// close all sockets&streams we have opened!
			if (sproxy!=null) {
				pbr.close();
				pbw.close();
				sproxy.close();
			}	
			bw.close();
			br.close();
			s.close();
		}
		catch (Exception ex) {
			System.out.println("Warning: "+ex+"\n");
		}
		System.out.println("Proxy for "+s+" stopped\n");
		// bye ...
		return;
	}
	
}
